diff -pruN 2.01-3/debian/changelog 2.01-4/debian/changelog
--- 2.01-3/debian/changelog	2023-04-18 16:22:28.000000000 +0000
+++ 2.01-4/debian/changelog	2024-04-05 01:32:43.000000000 +0000
@@ -1,3 +1,13 @@
+gkermit (2.01-4) unstable; urgency=medium
+
+  * QA upload.
+  * Fix building with -Werror=implicit-function-declaration.
+    (Closes: #1066387)
+  * Declare Rules-Requires-Root: no.
+  * Enable all hardening flags.
+
+ -- Andreas Beckmann <anbe@debian.org>  Fri, 05 Apr 2024 03:32:43 +0200
+
 gkermit (2.01-3) unstable; urgency=low
 
   * Orphan package - see bug 1034447.
diff -pruN 2.01-3/debian/control 2.01-4/debian/control
--- 2.01-3/debian/control	2023-04-18 16:22:28.000000000 +0000
+++ 2.01-4/debian/control	2024-04-05 01:32:43.000000000 +0000
@@ -4,6 +4,7 @@ Priority: optional
 Maintainer: Debian QA Group <packages@qa.debian.org>
 Standards-Version: 3.8.0
 Build-Depends: debhelper-compat (= 13)
+Rules-Requires-Root: no
 Homepage: https://www.kermitproject.org/gkermit.html
 Vcs-Git: https://salsa.debian.org/debian/gkermit.git
 Vcs-Browser: https://salsa.debian.org/debian/gkermit
diff -pruN 2.01-3/debian/patches/01-progress-indicator.patch 2.01-4/debian/patches/01-progress-indicator.patch
--- 2.01-3/debian/patches/01-progress-indicator.patch	2023-04-18 16:22:28.000000000 +0000
+++ 2.01-4/debian/patches/01-progress-indicator.patch	2024-04-05 01:32:43.000000000 +0000
@@ -8,11 +8,9 @@ Subject: Adds progress indicator
  gkermit.h  | 1 +
  3 files changed, 11 insertions(+)
 
-diff --git a/gcmdline.c b/gcmdline.c
-index 18d3bb7..3d2f150 100644
 --- a/gcmdline.c
 +++ b/gcmdline.c
-@@ -289,6 +289,11 @@ doarg(x) char x;
+@@ -287,6 +287,11 @@ doarg(x) char x;
  	    quiet = 1;
  	    break;
  
@@ -24,11 +22,9 @@ index 18d3bb7..3d2f150 100644
  	  case 'K':			/* Keep incompletely received files */
  	    keep = 1;
  	    break;
-diff --git a/gkermit.c b/gkermit.c
-index 083fb36..d85b0b3 100644
 --- a/gkermit.c
 +++ b/gkermit.c
-@@ -103,6 +103,7 @@ char **cmlist = NULL;			/* Pointer to file list in argv */
+@@ -114,6 +114,7 @@ char **cmlist = NULL;			/* Pointer to fi
  
  FILE * db = NULL;			/* Debug log file pointer */
  int debug = 0;				/* Debugging on */
@@ -36,7 +32,7 @@ index 083fb36..d85b0b3 100644
  int failure = 0;			/* Return status */
  int retries = 0;			/* Packet retry counter */
  int sendtype = 0;			/* Type of last packet sent */
-@@ -279,10 +280,14 @@ input() {				/* to get the next packet. */
+@@ -290,10 +291,14 @@ input() {				/* to get the next packet.
      return(type);			/* Return its type */
  }
  
@@ -51,11 +47,9 @@ index 083fb36..d85b0b3 100644
  }
  
  int
-diff --git a/gkermit.h b/gkermit.h
-index 65e9a8c..38a2c7e 100644
 --- a/gkermit.h
 +++ b/gkermit.h
-@@ -247,6 +247,7 @@ extern int errno;
+@@ -268,6 +268,7 @@ extern int errno;
  #endif /* ERRNO_H */
  #ifndef _GKERMIT_C
  extern int debug;
diff -pruN 2.01-3/debian/patches/hardening.patch 2.01-4/debian/patches/hardening.patch
--- 2.01-3/debian/patches/hardening.patch	1970-01-01 00:00:00.000000000 +0000
+++ 2.01-4/debian/patches/hardening.patch	2024-04-05 01:32:43.000000000 +0000
@@ -0,0 +1,39 @@
+Author: Andreas Beckmann <anbe@debian.org>
+Description: pass all hardening flags
+
+--- a/makefile
++++ b/makefile
+@@ -38,7 +38,8 @@ MANEXT = 1
+ # Default compiler and flags
+ 
+ CC=cc
+-CFLAGS= -DPOSIX -O $(KFLAGS)
++CFLAGS	+= $(CPPFLAGS)
++CFLAGS	+= -DPOSIX -O $(KFLAGS)
+ 
+ # Object files
+ 
+@@ -52,12 +53,12 @@ gwart.o:	gwart.c
+ 		$(CC) $(CFLAGS) -c gwart.c
+ 
+ gwart:		gwart.o
+-		$(CC) -o gwart gwart.o
++		$(CC) $(LDFLAGS) -o gwart gwart.o
+ 
+ .c.o:
+ 		$(CC) $(CFLAGS) -c $<
+ 
+-gproto.c:	gproto.w gkermit.h
++gproto.c:	gwart gproto.w gkermit.h
+ 		./gwart gproto.w gproto.c
+ 
+ gkermit.o:	gkermit.c gkermit.h
+@@ -67,7 +68,7 @@ gunixio.o:	gunixio.c gkermit.h
+ gcmdline.o:	gcmdline.c gkermit.h
+ 
+ gkermit:	gproto.o gkermit.o gunixio.o gcmdline.o
+-		$(CC) -o gkermit $(OBJECTS)
++		$(CC) $(LDFLAGS) -o gkermit $(OBJECTS)
+ 
+ bsd:		gwart
+ 		$(MAKE) "CC=$(CC)" "CFLAGS=-DBSD -O $(KFLAGS)" gkermit
diff -pruN 2.01-3/debian/patches/missing-prototypes.patch 2.01-4/debian/patches/missing-prototypes.patch
--- 2.01-3/debian/patches/missing-prototypes.patch	1970-01-01 00:00:00.000000000 +0000
+++ 2.01-4/debian/patches/missing-prototypes.patch	2024-04-05 01:32:43.000000000 +0000
@@ -0,0 +1,23 @@
+Author: Andreas Beckmann <anbe@debian.org>
+Description: fix building with -Werror=implicit-function-declaration
+
+--- a/gkermit.c
++++ b/gkermit.c
+@@ -87,6 +87,7 @@ char *build =  "stty";
+ 
+ #define _GKERMIT_C
+ #include <stdio.h>
++#include <unistd.h>
+ #include "gkermit.h"
+ 
+ /* Forward declarations of functions used within this module... */
+--- a/gunixio.c
++++ b/gunixio.c
+@@ -84,6 +84,7 @@
+ #include <setjmp.h>			/* Longjumps */
+ #include <sys/stat.h>			/* File exist, file size */
+ #include <errno.h>			/* Error symbols */
++#include <unistd.h>
+ #include "gkermit.h"			/* gkermit definitions */
+ 
+ /* All versions of HP-UX need Xon/Xoff */
diff -pruN 2.01-3/debian/patches/series 2.01-4/debian/patches/series
--- 2.01-3/debian/patches/series	2023-04-18 16:22:28.000000000 +0000
+++ 2.01-4/debian/patches/series	2024-04-05 01:32:43.000000000 +0000
@@ -1,3 +1,5 @@
 00-debian-local-changes.patch
 01-progress-indicator.patch
 02-stdout-blocking-mode.patch
+missing-prototypes.patch
+hardening.patch
diff -pruN 2.01-3/debian/rules 2.01-4/debian/rules
--- 2.01-3/debian/rules	2023-04-18 16:22:28.000000000 +0000
+++ 2.01-4/debian/rules	2024-04-05 01:32:43.000000000 +0000
@@ -1,12 +1,7 @@
 #!/usr/bin/make -f
 
-DPKG_EXPORT_BUILDFLAGS = 1
-include /usr/share/dpkg/buildflags.mk
-include /usr/share/dpkg/architecture.mk
+# see FEATURE AREAS in dpkg-buildflags(1)
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 %:
 	dh $@
-
-override_dh_auto_build:
-	dpkg-architecture -f -a$(DEB_BUILD_ARCH) -c dh_auto_build -- CFLAGS="${CFLAGS} ${CPPFLAGS} ${LDFLAGS}" gwart
-	dh_auto_build -- CFLAGS="${CFLAGS} ${CPPFLAGS} ${LDFLAGS}"
